<?php

defined('_JEXEC') or die( 'Restricted access' );
global $mainframe;

require_once ($mainframe->getPath('admin_html'));
require_once ('language/english.php');
require_once ('functions.jdefender.php');
$checked_box = JArrayHelper::getValue($_GET, 'boxchecked', '0');
$show = JArrayHelper::getValue($_GET, 'show', '');
$act = JArrayHelper::getValue($_GET, 'act');

// get parameters from the URL or submitted form
$section = strval(JArrayHelper::getValue($_REQUEST, 'section', 'content'));
$task = JArrayHelper::getValue($_REQUEST, 'task', '');
$database =& JFactory::getDBO();

//$cid 		= josGetArrayInts( 'cid' );
if ($task != '')
{
  $func = $task;
}
elseif ($act != '')
{
  $func = $act;
}
else
{
  $act = JArrayHelper::getValue($_REQUEST, 'act', "");
  if ($act != '')
  {
    $func = $act;
  }
  else
  {
    $func = '';
  }
}

switch ($func)
{

case 'delete_similar':
  delete_similar("suspect");
  break;

case 'log':
  $catid = intval($mainframe->getUserStateFromRequest("catid{$option}", 'catid', 0));
  $limit = intval($mainframe->getUserStateFromRequest("viewlistlimit", 'limit', $mainframe->getCfg('list_limit')));
  $limitstart = intval($mainframe->getUserStateFromRequest("view{$option}limitstart",
    'limitstart', 0));
  $database->setQuery("SELECT COUNT(*) FROM #__jguard_log");
  $total = $database->loadResult();
  require_once (JPATH_SITE . '/administrator/includes/pageNavigation.php');
  $pageNav = new mosPageNav($total, $limitstart, $limit);
  if (!isset($_POST['filter']))
  {
    $_POST['filter'] = 'none';
  }
  if (!isset($_POST['filter2']))
  {
    $_POST['filter2'] = 'none';
  }

  Jguard_html::show_log($pageNav, $limit, $limitstart, $_POST['filter'], $_POST['filter2']);
  break;

case 'options':
  Jguard_html::show_options();
  break;

case 'save_options':
  validate();
  save_options();
  break;

case 'block_list':
  $catid = intval($mainframe->getUserStateFromRequest("catid{$option}", 'catid', 0));
  $limit = intval($mainframe->getUserStateFromRequest("viewlistlimit", 'limit', $mainframe->getCfg('list_limit')));
  $limitstart = intval($mainframe->getUserStateFromRequest("view{$option}limitstart",
    'limitstart', 0));
  $database->setQuery("SELECT COUNT(*) FROM #__jguard_block_list");
  $total = $database->loadResult();
  require_once (JPATH_SITE . '/administrator/includes/pageNavigation.php');
  $pageNav = new mosPageNav($total, $limitstart, $limit);
  Jguard_html::show_block_list($pageNav, $limit, $limitstart);
  break;

case 'restore':
  //$catid 		= intval( $mainframe->getUserStateFromRequest( "catid{$option}", 'catid', 0 ) );
  $limit = intval($mainframe->getUserStateFromRequest("viewlistlimit", 'limit', $mainframe->getCfg('list_limit')));
  $limitstart = intval($mainframe->getUserStateFromRequest("view{$option}limitstart",
    'limitstart', 0));
  //$database->setQuery( "SELECT COUNT(*) FROM #__jguard_restore_log" );
  //$total = $database->loadResult();
  $total = 0;
  $folder = 'components/com_jdefender/restore';
  if ($dir = @opendir($folder))
  {
    while ($file = readdir($dir))
    {
      if (preg_match("/zip$/", $file) and $file != '.' and $file != '..')
      {
        $total = $total + 1;
      }
    }
    closedir($dir);
  }

  require_once (JPATH_SITE . '/administrator/includes/pageNavigation.php');
  $pageNav = new mosPageNav($total, $limitstart, $limit);
  Jguard_html::show_restore($pageNav, $limitstart, $limit);
  break;

case 'new_restore':
  Jguard_html::new_restore();
  break;

case 'create_restoration':
  set_time_limit(0);
  ignore_user_abort(true);
  create_restoration();
  break;

case 'restore_selected':
  set_time_limit(0);
  ignore_user_abort(true);
  if (count($_POST[files]) > 1)
  {
    $message = RST_ONLY_ONE;
    $mainframe->redirect("index2.php?option=com_jdefender&task=restore", $message);
  }
  else
  {

    if (jdRestoreSelected($_POST[files]))
    {
      $message = RST_APP_SUCC;
      $mainframe->redirect("index2.php?option=com_jdefender&task=restore", $message);
    }
    else
    {
      $message = RST_APP_FAIL;
      $mainframe->redirect("index2.php?option=com_jdefender&task=restore", $message);
    }

  }
  break;

case 'delete_restore':
  jdDeleteRestore();
  break;

case 'delete_suspect':
  delete_checked('suspect');
  break;

case 'delete_all_suspect':
  delete_checked('suspect', 'all');
  break;

case 'delete_reject':
  delete_checked('reject');
  break;

case 'delete_all_reject':
  delete_checked('reject', 'all');
  break;

case 'unblock_params':
  unblock_params();
  break;

case 'block_param_ip':
  block_param_ip();
  break;
  
case 'block_param':
  block_param();
  break;  

case 'unblock_all_params':
  unblock_params("all");
  break;

case 'show_card':
  show_card();
  break;

default:

  $catid = intval($mainframe->getUserStateFromRequest("catid{$option}", 'catid', 0));
  $limit = intval($mainframe->getUserStateFromRequest("viewlistlimit", 'limit', $mainframe->getCfg('list_limit')));
  $limitstart = intval($mainframe->getUserStateFromRequest("view{$option}limitstart", 'limitstart', 0));
  $database->setQuery("SELECT COUNT(*) FROM #__jguard_log");
  $total = $database->loadResult();

  require_once (JPATH_SITE . '/administrator/includes/pageNavigation.php');
  $pageNav = new mosPageNav($total, $limitstart, $limit);
  if (!isset($_POST['filter']))
  {
    $_POST['filter'] = 'none';
  }
  if (!isset($_POST['filter2']))
  {
    $_POST['filter2'] = 'none';
  }
  Jguard_html::show_log($pageNav, $limit, $limitstart, $_POST['filter'], $_POST['filter2']);
  break;
}
function unblock_params($what = '')
{
  global $mainframe;
  $database =& JFactory::getDBO();
  
  if ($what == '')
  {
    foreach ($_POST["check_id"] as $id)
    {
      $database->setQuery("DELETE FROM #__jguard_block_list WHERE `id`='" . $id . "'");
      $database->query();
    }
    $message = "Parameters were unblocked successfully.";
    $mainframe->redirect("index2.php?option=com_jdefender&task=block_list", $message);
  }
  else
  {
    $database->setQuery("DELETE FROM #__jguard_block_list");
    $database->query();

    $message = "All parameters were unblocked successfully.";
    $mainframe->redirect("index2.php?option=com_jdefender&task=block_list", $message);
  }
}

function delete_similar($log)
{  
  global $mainframe;
  $database =& JFactory::getDBO();
  
  if ($_GET["delete_without_login"] == 1)
  {
    /*IMPORTANT********************************
    *				IMPORTANT			*
    *******************************************/
    $database->setQuery("DELETE FROM `#__jguard_log` WHERE `user_id`= '0'");
    $database->query();

    $message = "Records were deleted successfully";
    $mainframe->redirect("index2.php?option=com_jdefender&task=log_" . $log , $message);
  }
  if ($_GET["delete_all_similar_ip"])
  {
    $database->setQuery("DELETE FROM `#__jguard_log` WHERE `ip`='" . $_GET["delete_all_similar_ip"] .
      "'");
    $database->query();

    $message = "Records were deleted successfully";
    $mainframe->redirect("index2.php?option=com_jdefender&task=log", $message);
  }
  if ($_GET["delete_all_similar_login"])
  {
    $database->setQuery("DELETE FROM `#__jguard_log` WHERE `user_id`= '" . $_GET["delete_all_similar_login"] .
      "'");
    $database->query();

    $message = "Records were deleted successfully";
    $mainframe->redirect("index2.php?option=com_jdefender&task=log",$message);
  }
}
function delete_checked($log, $what = "")
{
  global $mainframe;
  $database =& JFactory::getDBO();
  
  if (!$what)
  {
    foreach ($_POST["check_id"] as $id)
    {
      $database->setQuery("DELETE FROM #__jguard_log WHERE `id`='" . $id . "'");
      $database->query();
    }
    $message = "Records were deleted successfully";
    $mainframe->redirect("index2.php?option=com_jdefender&task=log", $message);
  }
  else
  {
    $database->setQuery("DELETE FROM #__jguard_log");
    $database->query();

    $message = "All records were deleted successfully";
    $mainframe->redirect("index2.php?option=com_jdefender&task=log_" . $log, $message);
  }
}
function validate()
{
  global $mainframe;
  if (($_POST['params']['untiflood'] == 1 && ((!is_numeric($_POST['params']['flood_queries_1']) || $_POST['params']['flood_queries_1'] ==
    "" || $_POST['params']['flood_queries_1'] == 0) || (!is_numeric($_POST['params']['flood_time_1']) || $_POST['params']['flood_time_1'] ==
    "" || $_POST['params']['flood_time_1'] == 0))) || ($_POST['params']['block_flood_else_1'] == 1 && ((!
    is_numeric($_POST['params']['flood_queries_2']) || $_POST['params']['flood_queries_2'] == "" || $_POST['params']['flood_queries_2'] ==
    0) || (!is_numeric($_POST['params']['flood_time_2']) || $_POST['params']['flood_time_2'] == "" || $_POST['params']['flood_time_2'] ==
    0))) || ($_POST['params']['block_flood_else_2'] == 1 && ((!is_numeric($_POST['params']['flood_queries_3']) ||
    $_POST['params']['flood_queries_3'] == "" || $_POST['params']['flood_queries_3'] == 0) || (!is_numeric
    ($_POST['params']['flood_time_3']) || $_POST['params']['flood_time_3'] == "" || $_POST['params']['flood_time_3'] ==
    0))))
  {

    $message = OPT_INCORRECT_ANTIFLOOD;
    $mainframe->redirect("index2.php?option=com_jdefender&task=options", $message);
  }
  else
  {
    if ($_POST['params']['block_flood_else_1'] == 1 and (is_numeric($_POST['params']['flood_time_2'])) and
      (is_numeric($_POST['params']['flood_queries_2'])))
    {
      $_POST['params']['flood_time_2'] *= 60;
    }
    if ($_POST['params']['block_flood_else_2'] == 1 and (is_numeric($_POST['params']['flood_time_3'])) and
      (is_numeric($_POST['params']['flood_queries_3'])))
    {
      $_POST['params']['flood_time_3'] *= 3600;
    }
  }
  if ($_POST['params']['send_email'] == 1)
  {
    if ($_POST['params']['email'] == '')
    {
      $message = OPT_EMAIL_REQUIRED;
      $mainframe->redirect("index2.php?option=com_jdefender&task=options", $message);
    }
    if (!preg_match("/[0-9a-z_\-]+@[0-9a-z_^\.\-]+\.[a-z]{2,3}/i", $_POST['params']['email']))
    {
      $message = OPT_INCORRECT_EMAIL;
      $mainframe->redirect("index2.php?option=com_jdefender&task=options", $message);
    }
  }
}
function save_options()
{
  global $mainframe;
  set_magic_quotes_runtime(0);
  $database =& JFactory::getDBO();
  
  //print '<pre>';print_r($_POST);print '</pre>';
  $data = getObjectList("select * from #__jguard_options");
  if (count($data) == 0)
  {
    $database->setQuery("insert into #__jguard_options (`id`) values ('1')");
    $database->query();
  }

  $mysql_parameter = $_POST['params']['mysql_parameter0'];
  $mysql_parameter .= " " . $_POST['params']['mysql_parameter1'];
  $mysql_parameter .= " " . $_POST['params']['mysql_parameter2'];
  $mysql_parameter .= " " . $_POST['params']['mysql_parameter3'];

  $file_parameter = $_POST['params']['file_parameter0'];
  $file_parameter .= " " . $_POST['params']['file_parameter1'];
  $update = " `mysql_scan` = '" . $_POST['params']['mysql_scan'] . "',";
  $update .= " `mysql_parameter` = '" . $mysql_parameter . "',";
  if (!get_magic_quotes_gpc()){
    $update .= " `mysql_keywords`='" . addslashes($_POST['params']['mysql_keywords']) . "',";
    $update .= " `file_keywords` = '" . addslashes($_POST['params']['file_keywords']) . "',";
  } else {
    $update .= " `mysql_keywords`='" . $_POST['params']['mysql_keywords'] . "',";
    $update .= " `file_keywords` = '" . $_POST['params']['file_keywords'] . "',";
  }
  $update .= " `file_scan` = '" . $_POST['params']['file_scan'] . "',";
  $update .= " `file_parameter` = '" . $file_parameter . "',";
  $update .= " `untiflood` = '" . $_POST['params']['untiflood'] . "',";
  $update .= " `flood_queries_1` = '" . $_POST['params']['flood_queries_1'] . "',";
  $update .= " `flood_time_1` = '" . $_POST['params']['flood_time_1'] . "',";
  $update .= " `flood_queries_2` = '" . $_POST['params']['flood_queries_2'] . "',";
  $update .= " `flood_time_2` = '" . $_POST['params']['flood_time_2'] . "',";
  $update .= " `flood_queries_3` = '" . $_POST['params']['flood_queries_3'] . "',";
  $update .= " `flood_time_3` = '" . $_POST['params']['flood_time_3'] . "',";
  $update .= " `flood_parameter` ='" . $_POST['params']['flood_parameter0'] . "',";
  $update .= " `send_email` = '" . $_POST['params']['send_email'] . "',";
  $update .= " `send_file_injection` = '" . $_POST['params']['send_php_injection'] . "',";
  $update .= " `send_mysql_injection` = '" . $_POST['params']['send_mysql_injection'] . "',";
  $update .= " `send_flood` = '" . $_POST['params']['send_flood'] . "',";
  $update .= " `email` = '" . $_POST['params']['email'] . "',";
  $update .= " `sql_exeptions`='" . $_POST['params']['sql_exeptions'] . "',";
  $update .= " `php_exeptions`='" . $_POST['params']['php_exeptions'] . "'";

  $database->setQuery("UPDATE #__jguard_options set " . $update);
  $database->query();
  $message = OPT_SAVE_SUCCESS;
  $mainframe->redirect("index2.php?option=com_jdefender&task=options", $message);
}

function jdDeleteRestore()
{
  global $mainframe;
  $archives = $_POST[files];
  print "<pre>";
  print_r($archives);
  print "</pre>";

  foreach ($archives as $arc)
  {
    if (unlink("backups/$arc"))
    {
      $message = RST_DELS;
    }
    else
    {
      $message = RST_DELSE;
    }
  }

  $mainframe->redirect("index2.php?option=com_jdefender&task=restore", $message);
}

function jdRestoreSelected($file)
{
   global $mainframe;
  $database =& JFactory::getDBO();
  
  include ('includes/pcl/pclzip.lib.php');
  foreach ($file as $key => $element)
  {
    $ziparchive = new PclZip("backups/{$element}");
    $ziparchive->extract(PCLZIP_OPT_PATH, JPATH_SITE);
  }
  if (file_exists(JPATH_SITE . '/cache/database_backup.sql'))
  {
    set_magic_quotes_runtime(0);
    $fp = fopen(JPATH_SITE . '/cache/database_backup.sql', "r");
    $content = fread($fp, filesize(JPATH_SITE . '/cache/database_backup.sql'));
    fclose($fp);
    $content = explode(";/*jdSePaRaTor*/", $content);
    $num_queries = count($content);
    $counter = 1;
    foreach ($content as $query)
    {
      print $query . "<br>";
      $database->setQuery($query);
      if ($database->query())
        $counter++;
      else
        print "<div align='left' style='color:red;'><pre>" . $database->getErrorMsg() . "</pre></div>";
      if ($counter == $num_queries)
      {
        unlink(JPATH_SITE.'/cache/database_backup.sql');
        return true;
      }
    }
  }  
}

  function block_param_ip()
  {
	global $mainframe;
	// Check for request forgeries
	JRequest::checkToken() or jexit( 'Invalid Token' );

	$cid	= JArrayHelper::getValue( $_REQUEST, 'check_id' );
	$option	= JRequest::getCmd( 'option' );
	$msg	= null;

	$database =& JFactory::getDBO();

    $database->setQuery("select ip FROM #__jguard_log WHERE `id`='" . $cid[0] . "'");
	$row = $database->loadObjectList();
	$value = $row[0]->ip;
	$msg = $database->getErrorMsg();
	
    if ($value)
    {
      $database->setQuery("select count(type) from #__jguard_block_list where `type`='ip' and `value`= '" . $value . "'");
	  $msg = $database->getErrorMsg();
      $count_rows = $database->loadResult();
      if ($count_rows == 0)
      {
        $database->setQuery("insert into #__jguard_block_list (`type`, `value`) values ('ip','" . $value . "')");
        $database->query();
      }
      else
      {
        $database->setQuery("DELETE FROM `#__jguard_block_list` WHERE `type`='ip' and `value`= '" . $value . "'");
        $database->query();
		$msg = $database->getErrorMsg();
      }
    }
		$cache = & JFactory::getCache('com_jdefender');
		$cache->clean();
		$mainframe->redirect('index.php?option='.$option, $msg);
  }
  function block_param()
  {
	global $mainframe;
	// Check for request forgeries

	$type	= JArrayHelper::getValue( $_REQUEST, 'type' );
	$value	= JArrayHelper::getValue( $_REQUEST, 'value' );
	$option	= JRequest::getCmd( 'option' );
	$msg	= null;

	$database =& JFactory::getDBO();
	
    if ($value)
    {
      $database->setQuery("select count(type) from #__jguard_block_list where `type`='" . $type .
        "' and `value`= '" . $value . "'");
      $count_rows = $database->loadResult();
      $msg = $database->getErrorMsg();

	  if ($count_rows == 0)
      {

	  $database->setQuery("insert into #__jguard_block_list (`type`, `value`) values ('" . $type .
          "','" . $value . "')");
        $database->query();
        $msg = $database->getErrorMsg();
      }
      else
      {

        $database->setQuery("DELETE FROM `#__jguard_block_list` WHERE `type`='" . $type .
          "' and `value`= '" . $value . "'");
        $database->query();
        $msg = $database->getErrorMsg();
      }
    }

    $mainframe->redirect('index.php?option='.$option, $msg);
  }  
?>