<?php
defined("_JEXEC") or die('Restricted Access');
jimport('joomla.event.plugin');

class plgSystemJdefender extends JPlugin
{

	var $jconfig = null;
	var $options = null;


	function plgSystemJdefender(&$subject)
	{

		global $mainframe;
		if ($mainframe->isAdmin()){
			return;
		}
		parent::__construct($subject);
		// load plugin parameters
		//$this->_plugin = JPluginHelper::getPlugin('system', 'Jdefender');
		//$this->_params = new JParameter($this->_plugin->params);
		if (empty($this->options))
		{
			$this->options = $this->jdGetOptions();
		}
		if (empty($this->jconfig))
		{
			$this->jconfig = new JConfig;
		}
	}

	function onAfterInitialise()
	{

		$database = &JFactory::getDBO();
		#SEARCHING FOR ALREADY BLOCKED USERS ******************************************************
		if ($this->jdFindBlocksOnStart())
		{
			$ip = getenv("REMOTE_ADDR");
			$referer = parse_url(getenv("http_referer"));
			$email = '<a href="mailto:' . $this->jconfig->mailfrom . '">' . $this->jconfig->mailfrom .'</a>';
			include ('plugins/system/message_pages/block_page.php');
			exit;
		}
		#SEARCHING FOR FLOOD *********************************************************************
		if ($this->jdFloodScan())
		{
			$ip = getenv("REMOTE_ADDR");
			$type = 'Flood';
			$key = 'No Value';
			$val = 'No Value';
			$email = '<a href="mailto:' . $this->jconfig->mailfrom . '">' . $this->jconfig->mailfrom .
			'</a>';
			include ('plugins/system/message_pages/stop_page.php');
			exit;
		}
		$this->jdInjectionScan();
		return true;
	}



	function jdGetOptions()
	{
		$database = &JFactory::getDBO();
		$sql = "SELECT * FROM #__jguard_options Where id = 1";
        $database->setQuery($sql);
		$result = $database->loadObjectList();
		$result = $result[0];
		foreach($result as $k=>$v)
		{
			$options[$k] = $v;
		}
		return $options;
	}

	function jdFindBlocksOnStart()
	{
		global $mainframe;
		$my = $mainframe->getUser();
		$user_id = $my->username;
		$UserIp = getenv("REMOTE_ADDR");
		$database = &JFactory::getDBO();
		$referer = getenv("http_referer");
		$query = "select count(`type`) from #__jguard_block_list where ";
		$query .= " (`type` = 'ip' and `value` = '" . $UserIp . "') ";
		$query .= " or (`type` = 'referer' and `value` = '" . $referer . "') ";
		$query .= " or (`type` = 'login' and `value` = '" . $user_id . "') ";
		$database->setQuery($query);
		$user_data = $database->loadObjectList();
		$count_blocks = $database->loadResult();

		if ($count_blocks > 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}


	function jdFloodScan()
	{
		$database = & JFactory::getDBO();
		$flood = false;
		$options = $this->options;
		$UserIp = getenv("REMOTE_ADDR");
		$database->setQuery("DELETE FROM `#__jguard_flood_monitor` WHERE `time` < (now() - INTERVAL 1 DAY)");
		$database->query();
		if ($options['untiflood'] == 1)
		{
			$database->setQuery("INSERT INTO #__jguard_flood_monitor (`ip`,`time`) " . "VALUES ('{$UserIp}', NOW())");
			$database->query();

			for ($i = 1; $i <= 3; $i++)
			{
				switch ($i)
				{
					case 1:
						$timeofset = " SECOND";
						break;
					case 2:
						$timeofset = " MINUT";
						break;
					case 3:
						$timeofset = " HOUR";
						break;
				}

				if (($options["flood_queries_".$i] > 0) && ($options["flood_time_" . $i] > 0))
				{
					$database->setQuery("SELECT COUNT(`ip`) FROM #__jguard_flood_monitor WHERE `ip` " .
					"= '{$UserIp}' AND `time` >= NOW() - INTERVAL " .
					$options["flood_time_" . $i] . " $timeofset");
					$count_queries = $database->loadResult();
					if ($count_queries >= $options["flood_queries_" . $i])
					{

						if (eregi(1, $options['flood_parameter']))
						{
							$this->jdAddBlockList("ip", $UserIp);
						}

						$flood = true;

					}
				}
			}

			if ($flood == true)
			{
				$database->setQuery("SELECT * FROM #__jguard_log WHERE `ip` = '{$UserIp}' and type = 'Flood'");
				$res = $database->loadResult();

				if ($res)
				{
					$database->setQuery("UPDATE #__jguard_log SET `ctime` = now() WHERE `ip` = '$UserIp' AND `type` = 'Flood'");
					$database->query();

				}
				else
				{
					$this->jdWriteLog('flood', 'reject');
				}
				if ($options['send_email'] == 1 and $options['send_flood'] == 1)
				{

					$this->jdSendMail("The attack of type Flood was Discovered on your site.", 'Flood');

				}
			}
		}

		return $flood;
	}


	function jdBlock($type, $key = '', $val = '')
	{
		global $mainframe;
		$database = &JFactory::getDBO();
		$options = $this->options;
		$log = false;
		if ($type == 'SQL injection')
		{
			$ip = (boolean)eregi(2, $options['mysql_parameter']);
			$login = (boolean)eregi(3, $options['mysql_parameter']);
			$log = (boolean)eregi(0, $options['mysql_parameter']);
			$block = (boolean)eregi(1, $options['mysql_parameter']);
			$tomail = (boolean)($options['send_email'] == 1 and $options['send_mysql_injection'] == 1);

		}
		else
		if ($type == 'PHP injection')
		{
			$ip = (boolean)eregi(1, $options['file_parameter']);
			$login = (boolean)eregi(0, $options['file_parameter']);
			$block = true;
			$tomail = (boolean)($options['send_email'] == 1 and $options['send_file_injection'] == 1);
		}

		$referer = getenv("http_referer");
		$ip2 = getenv("REMOTE_ADDR");
		$email = '<a href="mailto:' . $this->jconfig->mailfrom . '">' . $this->jconfig->mailfrom .
		'</a>';


		$_GET[$key] = '<b>' . $val . '</b>';
		$get = serialize($_GET);
		$_POST[$key] = '<b>' . $val . '</b>';
		$_COOKIE[$key] = '<b>' . $val . '</b>';
		$post = serialize($_POST);
		$my = $mainframe->getUser();
		$user_id = $my->username;

		$sql = "SELECT `id` FROM #__jguard_log WHERE `ip` = '{$ip2}' AND `url` = '{$get}' AND post = '{$post}' AND `type` = '{$type}'";
		$database->setQuery($sql);
		$result = $database->loadResult();


		if ($tomail && !$result)
		{
			$this->jdSendMail("The attack of type {$type} was Discovered on your site.", $type);
		}
		// bock ip address if needed;

		if ($log and !$block)
		{
			if (!$result)
			{
				$this->jdWriteLog($type, $block == true ? 'reject':'suspect');
			}
			else
			{
				$sql = "UPDATE #__jguard_log SET ctime = now() WHERE `id` = '{$result}'";
				$database->setQuery($sql);
				$database->query();
			}
		}

		if ($ip)
		{
			$this->jdAddBlockList('ip', $ip2);

		}

		if ($login)
		{
			$this->jdAddBlockList('login', $user_id);
		}

		if ($block)
		{

			if (!$result)
			{
				$this->jdWriteLog($type, 'reject');
				//include ('plugins/system/message_pages/stop_page.php');
			}
			else
			{

				$sql = "UPDATE #__jguard_log SET ctime = now() WHERE `id` = '$result'";
				$database->setQuery($sql);
				$database->query();
			}
		}
		if ($ip or $block or $login)
		{
			include ('plugins/system/message_pages/stop_page.php');
			//print for_blocked_user($ip2, $referer, $email, $type);
			exit;
		}

	}

	function jdWriteLog($type, $log)
	{
		global $mainframe;
		$database = &JFactory::getDBO();
		$my = $mainframe->getUser();
		$user_id = $my->username;
		$UserIp = getenv("REMOTE_ADDR");
		$get = serialize($_GET);
		$post = serialize($_POST);
		$ref = getenv("http_referer");
		$database->setQuery("insert into #__jguard_log (`ip`, `ctime`, `type`, `user_id`," .
		" `url`, `post`, `cook`, `referer`, `description`,`suspect_reject`) " .
		"values ('{$UserIp}', now(),'{$type}','{$user_id}','{$get}','{$post}', " .
		"'', '{$ref}', '', '{$log}')");
		$database->query();
	}



	function jdInjectionScan()
	{
		global $mainframe;
		$option = JRequest::getVar('option');
		$email = '<a href="mailto:' . $this->jconfig->mailfrom . '">' . $this->jconfig->mailfrom .'</a>';
		$options = $this->options;
		$gets = serialize($_GET);
		#SEARCHING FOR SQL injectionS START *************************************************
		if ($options['mysql_scan'] == 1)
		{
			$keywords = $options['mysql_keywords'];
			$keywords = explode("\n", str_replace("\r", '', $keywords));
			$skipwords = $this->jdGetSkipWords($option, $options['sql_exeptions']);


			foreach ($_REQUEST as $key => $val)
			{
				if (trim(@$key)=='' || @$key == null){continue;}
				//if (trim((string)$val) == '' || (string)$val = null){continue;}
				if (@is_array($val))
				{
					foreach ($val as $k=> $v)
					{
						if (trim($k)=='' || $k == null){continue;}
						if (trim($v) == '' || $v = null){continue;}
						if (@in_array(strtolower($key), @$skipwords) || $val ==='' || @in_array("*", @$skipwords))
						{
							continue;
						}
						foreach ($keywords as $keyword)
						{
							if (@preg_match($keyword, $val))
							{
								$this->jdBlock('SQL injection', $key, $val);
							}
						}
					}
				}


				if (@in_array(strtolower($key), @$skipwords) || $val ==='' || @in_array("*", @$skipwords) )
				{
					continue;
				}

				// check ereg rules
				foreach ($keywords as $keyword)
				{
					if (@preg_match($keyword, $val))
					{
						$this->jdBlock('SQL injection', $key, $val);
					}
				}
			}
		}
		//SEARCHING FOR  PHP INJECTIONS IN THE ADDRESS BAR
		if ($options['file_scan'] == 1)
		{
			$file_rules = $options['file_keywords'];
			$file_rules = explode("\n", str_replace("\r", "", $file_rules));
			$skipwords = $this->jdGetSkipWords($option, $options['php_exeptions']);
			$domain = preg_quote($this->jconfig->sitename, "/");


			foreach ($_REQUEST as $key => $val)
			{
				if (trim(@$key)=='' || @$key == null){continue;}
				//if (trim(@$val) == '' || @$val = null){continue;}

				if (@is_array($val))
				{
					foreach ($val as $k => $v)
					{
						if (trim($k)=='' || $k == null || empty($k)){continue;}
						if (trim($v) == '' || $v = null || empty ($v)){continue;}

						if (@in_array(strtolower($key), @$skipwords) || $val ==='' || @in_array("*", @$skipwords))
						{
							continue;
						}
						foreach ($keywords as $keyword)
						{
							if (@preg_match($keyword, $val))
							{
								$this->jdBlock('PHP injection', $key, $val);
							}
						}
					}
				}

				if (@in_array(strtolower($key), @$skipwords) || $val ==='' || @in_array("*", @$skipwords))
				{
					continue;
				}

				if (@preg_match("/^(http|https):\/\//", $val) and !@preg_match("/" . $domain . "/", $val))
				{
					if (@preg_match("/url|site|page|location|return/iU", $key))
					{
						continue;
					}
					else
					{
						$this->jdBlock('PHP injection', $key, $val);
					}
				}
				// check ereg rules
				foreach ($file_rules as $keyword)
				{
					if (@preg_match($keyword, $val))
					{
						$this->jdBlock('PHP injection', $key, $val);
					}
				}
			}
		}
		//SCANNIN THE FILES
		if (@$options['file_scan'] == 1)
		{
			if (count($_FILES)>0)
			{
				jimport('joomla.filesystem.file');
				foreach (@$_FILES as $key => $val)
				{
					if (is_array(@$_FILES[$key]['tmp_name']))
					{
						foreach (@$_FILES[$key]['tmp_name'] as $k=>$v)
						{
							$file_content = JFile::read(@$_FILES[$key]['tmp_name'][$k]);
							if (@preg_match("/<\?php(.+)\?>/siU", $file_content))
							{
								$this->jdBlock('PHP injection', "file_injection", "true");
							}
						}
					}
					else
					{
						if (@$_FILES[$key]['tmp_name']!='')
						{
							$fp = @fopen(@$_FILES[$key]['tmp_name'], "r");

							$file_content = fread($fp, @filesize(@$_FILES[$key]['tmp_name']));

							if (@preg_match("/<\?php(.+)\?>/siU", $file_content))
							{
								$this->jdBlock('PHP injection', "file_injection", "true");
							}
							@fclose($fp);
						}
					}
				}
			}
		}



	}


	function jdAddBlockList($type, $value)
	{
		$database = &JFactory::getDBO();

		if ($value)
		{
			$database->setQuery("select count(type) from #__jguard_block_list where `type`='" .
			$type . "' and `value`= '" . $value . "'");
			$count_rows = $database->loadResult();
			if ($count_rows == 0)
			{
				$database->setQuery("insert into #__jguard_block_list (`type`, `value`) values ('" .
				$type . "','" . $value . "')");
				$database->query();
			}
		}
	}
	function jdSendMail($subject, $type)
	{
		global $mainframe;
		$options = $this->options;

		$ip = getenv("REMOTE_ADDR");
		$referer = getenv("http_referer");
		$email = '<a href="mailto:' . $options['email'] . '">' . $options['email'] . '</a>';
		$text = "There was attack of type" . $type . " discovered on your site.\n";
		$text .= "\n";
		$text .= "Additional Information:\n";
		$text .= "---------------------------------------------\n";
		$text .= " TYPE:     $type\n";
		$text .= " IP:       $ip\n";
		$my = $mainframe->getUser();
		$text .= " USER:     [$my->id] $my->name\n";
		$text .= " REFERER:  $referer\n";
		$text .= " GET:      " . print_r($_GET, true) . "\n";
		$text .= " POST:     " . print_r($_POST, true) . "\n";
		$text .= " COOCKIE:  " . print_r($_COOKIE, true) . "\n";
		//$text .= " SESSION:  ".print_r($_SESSION, true)."\n";
		$text .= "---------------------------------------------\n";
		$text .= "\n";
		$text .= "JDefender Joomla Bot\n";
		JUtility::sendMail($this->jconfig->mailfrom, 'JDefender systembot', $options['email'], $subject, $text, 0);
	}

	function jdGetSkipWords($component, $val)
	{
		$out = array();
		if ($val)
		{
			$array = @explode("\n", str_replace("\r", '', $val));
			foreach ($array as $opt)
			{
				$tmp = explode("::", $opt);

				if ($tmp[0] == $component || $tmp[0]=='*')
				{
					$out[] = trim(strtolower(@$tmp[1]));
				}
			}
		}
		return $out;
	}

}

?>